export var isIeBrowser = function () {
    var userAgent = window.navigator.userAgent;
    var msie = userAgent.indexOf('MSIE ');
    var trident = userAgent.match(/Trident.*rv:11\./);
    return msie !== -1 || trident;
};
export var getContributorColumns = function (_a) {
    var contributors = _a.contributors, maxPerColumn = _a.maxPerColumn, graphUrl = _a.graphUrl;
    var columnIndex = 0;
    return contributors.reduce(function (columns, stats, i) {
        var userId = stats[0];
        var contributor = {
            userId: userId,
            count: stats[1],
            ranking: i + 1,
            avatarUrl: graphUrl + "/" + userId + "/picture",
        };
        if (columns[columnIndex].length >= maxPerColumn) {
            columnIndex += 1;
            columns.push([contributor]);
            return columns;
        }
        columns[columnIndex].push(contributor);
        return columns;
    }, [[]]);
};
export var configureSessionProgress = function (progress, ownerId) {
    if (!ownerId) {
        return null;
    }
    var value = progress.value, completed = progress.completed, total = progress.total;
    if (!value) {
        return {
            value: 0,
            completed: 0,
            total: 0,
        };
    }
    var calculatedValue = (Number(completed) / Number(total)) * 100;
    return {
        value: calculatedValue,
        completed: Number(completed),
        total: Number(total),
    };
};
export var formatNumber = function (n) {
    if (n >= 1000 || n <= -1000) {
        return parseFloat((n / 1000).toFixed(1)) + "k";
    }
    return String(n);
};
