var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import React from 'react';
import { Button } from "../../../inputs";
import { configureSessionProgress } from '../../utils';
var OGIT_SPEC_URL = 'https://arago.github.io/OGIT';
var createOriginNodeLink = function (type) {
    var ogit = type.replace(/\//g, '');
    return {
        name: type,
        url: OGIT_SPEC_URL + "/group__httpwwwpurlorg" + ogit + ".html",
    };
};
var configureButtonTitle = function (userAccountId, conversionReviewers, owner) {
    if (userAccountId === owner) {
        return 'Continue Conversion';
    }
    if (conversionReviewers) {
        return 'Review';
    }
    if (!owner) {
        return 'Start Conversion';
    }
    return 'View';
};
var configureOriginNodeUrl = function (client, originNodeId) { return __awaiter(void 0, void 0, void 0, function () {
    var originNode, error_1;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                _a.trys.push([0, 2, , 3]);
                return [4 /*yield*/, client.get(originNodeId)];
            case 1:
                originNode = _a.sent();
                return [2 /*return*/, originNode ? createOriginNodeLink(originNode['ogit/_type']) : null];
            case 2:
                error_1 = _a.sent();
                console.warn(originNodeId + " Origin Node not found");
                return [2 /*return*/, null];
            case 3: return [2 /*return*/];
        }
    });
}); };
export var handleConversionSessionData = function (client, openApp, appIds, userId) { return function (session) { return __awaiter(void 0, void 0, void 0, function () {
    var katId, ivId, progressValue, conversionOwnerId, buttonTitle, openSessionButton, actions, sessionData, knowledgeOwner, _a, issue, commentsQuery, commentsCount, originNodeId, issueId_1, openInIVButton, descriptionActions, originNodeHref, _b, error_2;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0:
                katId = appIds[0], ivId = appIds[1];
                progressValue = configureSessionProgress({
                    value: session['/teaching_ki_progress'],
                    completed: session['/teaching_steps_deployed'],
                    total: session['/teaching_steps'],
                }, session['/teaching_conversion_ownerId']);
                conversionOwnerId = session['/teaching_conversion_ownerId'];
                buttonTitle = configureButtonTitle(userId, session['/conversion_reviewer_ids'], conversionOwnerId);
                openSessionButton = (React.createElement(Button, { key: session['ogit/_id'], onClick: function () {
                        return openApp(katId, { action: 'open-session', id: session['ogit/_id'] });
                    }, color: conversionOwnerId ? 'secondary' : 'primary' }, buttonTitle));
                actions = [openSessionButton];
                sessionData = {
                    id: session['ogit/_id'],
                    name: session['ogit/title'] || '',
                    progress: progressValue,
                    started: Boolean(conversionOwnerId),
                    conversionReviewerIds: session['/conversion_reviewer_ids'],
                    actions: actions,
                };
                _c.label = 1;
            case 1:
                _c.trys.push([1, 8, , 9]);
                _a = session['/teaching_ownerId'];
                if (!_a) return [3 /*break*/, 3];
                return [4 /*yield*/, client.auth.getAccount(session['/teaching_ownerId'])];
            case 2:
                _a = (_c.sent()).account['ogit/name'];
                _c.label = 3;
            case 3:
                knowledgeOwner = _a;
                return [4 /*yield*/, client.gremlin(session['ogit/_id'], 'inE("ogit/relates").has("ogit/_out-type", "ogit/Automation/AutomationIssue").outV()')];
            case 4:
                issue = (_c.sent())[0];
                commentsQuery = "(\n        +ogit\\/_type:\"ogit/Comment\"\n        +\\/kat_type: review_comment\n        +\\/session_id:\"" + session['ogit/_id'] + "\"\n        +\\/author_role:\"AIE\"\n      )";
                return [4 /*yield*/, client.lucene(commentsQuery, {
                        limit: -1,
                        count: true,
                    })];
            case 5:
                commentsCount = (_c.sent())[0];
                originNodeId = issue && issue['ogit/Automation/originNode'];
                issueId_1 = issue && issue['ogit/_id'];
                openInIVButton = (React.createElement(Button, { key: issueId_1, onClick: function () { return openApp(ivId, { action: 'open-issue', id: issueId_1 }); }, color: "primary" }, "Inspect in Task Inspector"));
                descriptionActions = issueId_1 ? [openInIVButton] : [];
                _b = originNodeId;
                if (!_b) return [3 /*break*/, 7];
                return [4 /*yield*/, configureOriginNodeUrl(client, originNodeId)];
            case 6:
                _b = (_c.sent());
                _c.label = 7;
            case 7:
                originNodeHref = _b;
                return [2 /*return*/, __assign(__assign({}, sessionData), { commentsCount: commentsCount, knowledgeOwner: knowledgeOwner || '', originNodeHref: originNodeHref || null, descriptionActions: descriptionActions })];
            case 8:
                error_2 = _c.sent();
                console.error(error_2);
                return [2 /*return*/, __assign(__assign({}, sessionData), { knowledgeOwner: '' })];
            case 9: return [2 /*return*/];
        }
    });
}); }; };
