import React from 'react';
import { useInfiniteScroll } from './useInfiniteScroll';
import { FixedContainer, RootFlexContainer, ScrollableContainer, } from './styles';
import { DefaultListLoading } from './DefaultLoading';
import { DefaultListLoadMore } from './DefaultLoadMore';
export var LazyList = function (_a) {
    var hasNextPage = _a.hasNextPage, loading = _a.loading, _b = _a.items, items = _b === void 0 ? [] : _b, loadNextPage = _a.loadNextPage, threshold = _a.threshold, withPrefetchedData = _a.withPrefetchedData, _c = _a.renderRoot, Root = _c === void 0 ? RootFlexContainer : _c, renderRow = _a.renderRow, _d = _a.renderLoading, Loading = _d === void 0 ? DefaultListLoading : _d, _e = _a.renderLoadMore, LoadMore = _e === void 0 ? DefaultListLoadMore : _e;
    var _f = useInfiniteScroll({
        loading: loading,
        hasNextPage: hasNextPage,
        onLoadMore: loadNextPage,
        threshold: threshold,
        withPrefetchedData: withPrefetchedData,
    }), infiniteRef = _f.ref, showLoadMore = _f.showLoadMore;
    return (React.createElement(Root, null,
        React.createElement(FixedContainer, { ref: infiniteRef },
            React.createElement(ScrollableContainer, null,
                items.map(renderRow),
                loading && React.createElement(Loading, null),
                showLoadMore && React.createElement(LoadMore, { loadNextPage: loadNextPage })))));
};
