import React from 'react';
import { TableBody } from '../Table';
import { useInfiniteScroll } from './useInfiniteScroll';
import { RootFlexContainer, Wrapper } from './styles';
import { DefaultTableLoading } from './DefaultLoading';
import { DeafultTableLoadMore } from './DefaultLoadMore';
export var LazyTable = function (_a) {
    var hasNextPage = _a.hasNextPage, loading = _a.loading, _b = _a.items, items = _b === void 0 ? [] : _b, loadNextPage = _a.loadNextPage, threshold = _a.threshold, withPrefetchedData = _a.withPrefetchedData, _c = _a.renderRoot, Root = _c === void 0 ? RootFlexContainer : _c, Table = _a.renderTable, Header = _a.renderHeader, renderRow = _a.renderRow, _d = _a.renderLoading, Loading = _d === void 0 ? DefaultTableLoading : _d, _e = _a.renderLoadMore, LoadMore = _e === void 0 ? DeafultTableLoadMore : _e;
    var _f = useInfiniteScroll({
        loading: loading,
        hasNextPage: hasNextPage,
        onLoadMore: loadNextPage,
        threshold: threshold,
        withPrefetchedData: withPrefetchedData,
    }), infiniteRef = _f.ref, scrollbarWidth = _f.scrollbarWidth, showLoadMore = _f.showLoadMore, tableMaxHeight = _f.tableMaxHeight;
    return (React.createElement(Root, null,
        React.createElement(Wrapper, { scrollbarWidth: scrollbarWidth },
            React.createElement(Table, null,
                React.createElement(Header, null),
                React.createElement(TableBody, { ref: infiniteRef, maxHeight: tableMaxHeight },
                    items.map(renderRow),
                    loading && React.createElement(Loading, null),
                    showLoadMore && React.createElement(LoadMore, { loadNextPage: loadNextPage }))))));
};
