import React, { ReactElement } from 'react';
import { HiroColors } from '../../../types';
import { DropDirection, ItemsDirection } from './constants';
export interface TinyDropMenuProps {
    color?: HiroColors;
    dropDirection?: DropDirection;
    itemsDirection?: ItemsDirection;
    closeOnItemClick?: boolean;
    renderTrigger?: (props: RenderTriggerProps) => React.ReactNode;
    onOpen?: (dropDirection?: DropDirection) => void;
    onClose?: () => void;
}
export interface RenderTriggerProps {
    open: boolean;
    openMenu: () => void;
    closeMenu: () => void;
}
export interface TinyDropMenuItemProps {
    onClick: () => void;
    renderIcon: ({ hovering }: {
        hovering: boolean;
    }) => ReactElement;
    renderTitle: () => ReactElement;
    disabled?: boolean;
}
export declare const TinyDropMenu: React.FC<TinyDropMenuProps>;
export declare const TinyDropMenuItem: React.FC<TinyDropMenuItemProps>;
