var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React, { useMemo } from 'react';
import { New } from './New';
import { Stopped } from './Stopped';
import { Waiting } from './Waiting';
import { Resolved } from './Resolved';
import { Terminated } from './Terminated';
import { Processing } from './Processing';
export var Status = function (_a) {
    var status = _a.status, show = _a.show, rest = __rest(_a, ["status", "show"]);
    var _b = useMemo(function () {
        switch (status) {
            case 'NEW':
                return [New, 'grey'];
            case 'STOPPED':
                return [Stopped, 'red'];
            case 'WAITING':
                return [Waiting, 'orange'];
            case 'RESOLVED':
                return [Resolved, 'green'];
            case 'TERMINATED':
                return [Terminated, 'purple'];
            case 'PROCESSING':
                return [Processing, 'blue'];
            default:
                return [];
        }
    }, [status]), Icon = _b[0], color = _b[1];
    if (!Icon) {
        return null;
    }
    return React.createElement(Icon, __assign({}, rest, { color: color }));
};
